using System.Collections;
using System.Collections.Generic;

namespace Duotris
{
    public interface IGameList
    {
        void Add(string player1, string player2);
        string this[string player] { get; }
    }

    public class GameList : IGameList, IEnumerable<KeyValuePair<string, string>>
    {
        private IDictionary<string, string> matches = new Dictionary<string, string>();

        public void Add(string player1, string player2)
        {
            // Add players to list. Note that we do this two-way for easy lookup.
            matches.Add(player1, player2);
            matches.Add(player2, player1);
        }

        public string this[string player] 
        {
            get
            {
                return matches[player];
            }
        }

        public IEnumerator<KeyValuePair<string, string>> GetEnumerator()
        {
            return matches.GetEnumerator();
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return ((IEnumerable)matches).GetEnumerator();
        }
   }
}