using System.Collections.Generic;

namespace Duotris
{
    public interface IPlayerQueue
    {
        void Enqueue(string player);
        string Dequeue();
        int Count { get; }
    }

    public class PlayerQueue : IPlayerQueue
    {
        private Queue<string> queue = new Queue<string>();

        public void Enqueue(string player)
        {
            queue.Enqueue(player);
        }

        public string Dequeue()
        {
            return queue.Dequeue();
        }

        public int Count
        {
            get { return queue.Count; }
        }
    }
}