// WARNING: remember when you see this that this code is derived from the size-coding
//          version at joriszwart.nl/games/javascript-tetris-1.5kb and thus outdated, naive and unmaintainable.
//
//          It was quickly hacked to create two buckets and the such. No DRY, no SOLID! Globals
//          galore.
//
//          The left bucket is the keyboard player. The right bucket is the remote player.
//          When a player clears 4 lines at once, the opponent receives a scrambled line.

var d = document,
    W = 10,
    H = 25,
    s = l = 0,      // score, lines cleared
    Y, t,           // block row, timer id
    colors = [
        'cyan',         // I
        'blue',         // J
        'orange',       // L
        'yellow',       // O
        'lime',         // S
        'purple',       // T
        'red'           // Z
    ]

function addRow(bucket, width) {
    for (r = bucket.insertRow(0), x = width; x--;) {
        r.insertCell(0).appendChild(d.createTextNode('\u00a0'))
    }
}

function iterate(b, R, a) {
    for (i = 4; i--;) {
        q = (   'defgaeimdefgaeim' +    // I
                'defjaeibdhijibfj' +    // J
                'dhefaeijhifjabfj' +    // L
                'eifjeifjeifjeifj' +    // O
                'heifaefjheifaefj' +    // S
                'deifaeifheijebfj' +    // T
                'deijeibfdeijeibf')     // Z
                    .charCodeAt(b * 16 + R * 4 + i) - 96
        a(q % 4, q >> 2)
    }
}

function draw(bucket, c, Y, b, r) {
    iterate(b, r, function(x, y) {
        v = bucket.rows[Y + y].cells[X + x]
        v.className = c ? colors[b] : 'cleared'
        v.s = c     // mark as set (later on used to test if a block is taken or not)
        v.block = b
    })
}

function move(O, P, R) {
    // clear block (actually we only have to clear the markers (cell.s),
    // but this saves our precious bytes!)
    draw(first, 0, Y, b, r)
    c = 4       // bricks per block (FIXME makes no sense to set this to 4, could be a boolean instead)

    // test if block can be placed at new position
    iterate(b, R, function(x, y) {
        x += X + O
        y += Y + P
        if (x < 0 || x >= W || y >= H || first.rows[y].cells[x].s) c = 0
    })
    if (c) {    // yes, we can
        X += O
        Y += P
        r = R
    }

    // place the block at the old or new position
    draw(first, 1, Y, b, r)

    // convert table data to array data (yes, ES6 please :-D)
    var bucket = []
    for(var row = 0; row < first.rows.length; row++) {
        var rowData = []
        for(var column = 0; column < first.rows[row].cells.length; column++) {
            rowData.push(first.rows[row].cells[column].s ? first.rows[row].cells[column].block : -1)
        }
        bucket.push(rowData)
    }

    // TODO handle disconnect
    connection.send('Move', bucket, s, l)

    return c
}

function Newblock() {
    X = 0
    draw(firstPreview, 0, 0, n, 0)   // clear preview

    // remove lines that are full
    for (p = 0, y = Y; y < H; y++) {
        for (f = 0, x = W; x--;) f |= !first.rows[y].cells[x].s
        if (!f) {
            first.deleteRow(y)
            addRow(first, W)
            p++
        }
    }
    if(p > 0) {
        connection.send('LinesCleared', p)
    }

    // original: MMV instead of 2005 (shaves off one byte :s)
    d.getElementById('s').innerHTML = 'Score: ' + (s += 9 << p) + '\nLines: ' + (l += p)
    clearInterval(t)
    t = setInterval(F, 650 - l)

    // play along with the previously choosen preview block,
    // choose a new preview block and draw it as well
    b = n
    n = new Date() % 7
    draw(firstPreview, 1, 0, n, 0)   // draw preview

    // initial position for new block
    Y = 0
    X = 3
    r = 0

    // game over check, if the newly choosen block cannot be placed -> it's over
    if (!move(0, 1, r)) {
        clearInterval(t)
        drawText(first, '      ', 2, 3)
        drawText(first, ' GAME ', 2, 4)
        drawText(first, '      ', 2, 5)
        drawText(first, ' OVER ', 2, 6)
        drawText(first, '      ', 2, 7)
        // TODO detach keyboard listener to prevent further playing
    }
}

function drawText(bucket, text, x, y) {
    for(var i = 0; i < text.length; i++) {
        bucket.rows[y].cells[x + i].innerHTML = text.charAt(i)
        bucket.rows[y].cells[x + i].style.background = ''
        bucket.rows[y].cells[x + i].style.border = ''
        bucket.rows[y].cells[x + i].className = 'cleared'
    }
}

function F() {
    if (!move(0, 1, r)) {
        Newblock()
    }
}

// keyboard handling - both cursor and vi-bindings
function k(e) {
    switch (e.which || event.keyCode) {
        case 74:      // move left
        case 37:
            move(-1, 0, r)
            break
        case 75:      // move right
        case 38:
            move(0, 0, (r + 1) % 4)
            break
        case 76:      // rotate
        case 39:
            move(1, 0, r)
            break
        case 32:      // drop
            clearInterval(t)
            t = setInterval(F, 9)
        case 73:      // move down
        case 40:
        case 77:
            F()
    }
}

first = d.getElementById('first')
second = d.getElementById('second')
firstPreview = d.getElementById('firstPreview')

// initial block
b = new Date() % 7
n = new Date() % 7
S = first.rows
for (y = H; y--;) {     // draw buckets
    addRow(first, W)
    addRow(second, W)
}
for (var y = 0; y < 4; y++) {   // draw previews
    addRow(firstPreview, 4)
}
